| OpenCV 3.4.1 Open Source Computer Vision

Public Types | Public Member Functions | List of all members
cvflann::Index< Distance > Class Template Reference

`#include "flann_base.hpp"`

Inheritance diagram for cvflann::Index< Distance >:

## Public Types
typedef Distance::ResultType | DistanceType
typedef Distance::ElementType | ElementType

## Public Member Functions
| Index (const Matrix< ElementType > &features, const IndexParams &params, Distance distance=Distance())
| ~Index ()
void | buildIndex ()
void | findNeighbors (ResultSet< DistanceType > &result, const ElementType *vec, const SearchParams &searchParams)
| Method that searches for nearest-neighbours. More...
NNIndex< Distance > * | getIndex ()
| Returns actual index. More...
const IndexParams * | getIndexParameters ()
| Returns index parameters. More...
IndexParams | getParameters () const
flann_algorithm_t | getType () const
void | knnSearch (const Matrix< ElementType > &queries, Matrix< int > &indices, Matrix< DistanceType > &dists, int knn, const SearchParams &params)
| Perform k-nearest neighbor search. More...
virtual void | loadIndex (FILE *stream)
| Loads the index from a stream. More...
int | radiusSearch (const Matrix< ElementType > &query, Matrix< int > &indices, Matrix< DistanceType > &dists, float radius, const SearchParams &params)
| Perform radius search. More...
void | save (cv::String filename)
virtual void | saveIndex (FILE *stream)
| Saves the index to a stream. More...
size_t | size () const
virtual int | usedMemory () const
size_t | veclen () const
Public Member Functions inherited from cvflann::NNIndex< Distance >
virtual | ~NNIndex ()

## Member Typedef Documentation

## § DistanceType

template<typename Distance>

typedef Distance::ResultType cvflann::Index< Distance >::DistanceType

## § ElementType

template<typename Distance>

typedef Distance::ElementType cvflann::Index< Distance >::ElementType

## Constructor & Destructor Documentation

## § Index()

template<typename Distance>

cvflann::Index< Distance >::Index | ( | const Matrix< ElementType > & | features,
|  | const IndexParams & | params,
|  | Distance | distance = `Distance()`
| ) |  |
| inline

## § ~Index()

template<typename Distance>

cvflann::Index< Distance >::~Index | ( |  | ) |
| inline

## Member Function Documentation

## § buildIndex()

template<typename Distance>

void cvflann::Index< Distance >::buildIndex | ( |  | ) |
| inline virtual

Builds the index.

Implements cvflann::NNIndex< Distance >.

## § findNeighbors()

template<typename Distance>

void cvflann::Index< Distance >::findNeighbors | ( | ResultSet< DistanceType > & | result,
|  | const ElementType * | vec,
|  | const SearchParams & | searchParams
| ) |  |
| inline virtual

Method that searches for nearest-neighbours.

Implements cvflann::NNIndex< Distance >.

## § getIndex()

template<typename Distance>

NNIndex<Distance>* cvflann::Index< Distance >::getIndex | ( |  | ) |
| inline

Returns actual index.

## § getIndexParameters()

template<typename Distance>

const IndexParams* cvflann::Index< Distance >::getIndexParameters | ( |  | ) |
| inline

Returns index parameters.

Deprecated:
  use getParameters() instead.

## § getParameters()

template<typename Distance>

IndexParams cvflann::Index< Distance >::getParameters | ( |  | ) | const
| inline virtual

Returns
  The index parameters

Implements cvflann::NNIndex< Distance >.

## § getType()

template<typename Distance>

flann_algorithm_t cvflann::Index< Distance >::getType | ( |  | ) | const
| inline virtual

Returns
  The index type (kdtree, kmeans,...)

Implements cvflann::NNIndex< Distance >.

## § knnSearch()

template<typename Distance>

void cvflann::Index< Distance >::knnSearch | ( | const Matrix< ElementType > & | queries,
|  | Matrix< int > & | indices,
|  | Matrix< DistanceType > & | dists,
|  | int | knn,
|  | const SearchParams & | params
| ) |  |
| inline virtual

Perform k-nearest neighbor search.

Parameters

  [in] | queries | The query points for which to find the nearest neighbors
  [out] | indices | The indices of the nearest neighbors found
  [out] | dists | Distances to the nearest neighbors found
  [in] | knn | Number of nearest neighbors to return
  [in] | params | Search parameters

Reimplemented from cvflann::NNIndex< Distance >.

## § loadIndex()

template<typename Distance>

virtual void cvflann::Index< Distance >::loadIndex | ( | FILE * | stream | ) |
| inline virtual

Loads the index from a stream.

Parameters

  stream | The stream from which the index is loaded

Implements cvflann::NNIndex< Distance >.

## § radiusSearch()

template<typename Distance>

int cvflann::Index< Distance >::radiusSearch | ( | const Matrix< ElementType > & | query,
|  | Matrix< int > & | indices,
|  | Matrix< DistanceType > & | dists,
|  | float | radius,
|  | const SearchParams & | params
| ) |  |
| inline virtual

Perform radius search.

Parameters

  [in] | query | The query point
  [out] | indices | The indinces of the neighbors found within the given radius
  [out] | dists | The distances to the nearest neighbors found
  [in] | radius | The radius used for search
  [in] | params | Search parameters

Returns
  Number of neighbors found

Reimplemented from cvflann::NNIndex< Distance >.

## § save()

template<typename Distance>

void cvflann::Index< Distance >::save | ( | cv::String | filename | ) |
| inline

## § saveIndex()

template<typename Distance>

virtual void cvflann::Index< Distance >::saveIndex | ( | FILE * | stream | ) |
| inline virtual

Saves the index to a stream.

Parameters

  stream | The stream to save the index to

Implements cvflann::NNIndex< Distance >.

## § size()

template<typename Distance>

size_t cvflann::Index< Distance >::size | ( |  | ) | const
| inline virtual

Returns
  The dimensionality of the features in this index.

Implements cvflann::NNIndex< Distance >.

## § usedMemory()

template<typename Distance>

virtual int cvflann::Index< Distance >::usedMemory | ( |  | ) | const
| inline virtual

Returns
  The amount of memory (in bytes) used by the index.

Implements cvflann::NNIndex< Distance >.

## § veclen()

template<typename Distance>

size_t cvflann::Index< Distance >::veclen | ( |  | ) | const
| inline virtual

Returns
  number of features in this index.

Implements cvflann::NNIndex< Distance >.

The documentation for this class was generated from the following file:

- flann/include/opencv2/flann/flann_base.hpp